﻿Module Sieve
    Const MAXITER As Integer = 50000
    Sub Main()
        Dim flags(MAXITER) As Integer
        Dim i As Integer, k As Integer, iter As Integer, found As Integer
        Dim start As Double, finish As Double

        Console.WriteLine(Str(MAXITER) + " iterations")
        start = Timer
        For iter = 1 To MAXITER
            found = 0
            For i = 0 To MAXITER
                flags(i) = 0
            Next
            For i = 2 To MAXITER
                If flags(i) = 0 Then    ' found a prime
                    found = found + 1
                    For k = i + i To MAXITER Step i
                        flags(k) = 1
                    Next
                End If
            Next
        Next
        finish = Timer
        Console.WriteLine(Str(found) + " primes in " + Str(Int((finish - start) * 1000)) + " ms.")
        Console.ReadKey()
    End Sub

End Module
